
local player = {}
local enemies = {}

function newEnemy(x,y)
  enemy = {}
  enemy.x = x
  enemy.y = y
  enemy.width = 32
  enemy.height = 32
  enemy.removed = false
  enemy.pv = 4
  enemy.bump = 10
  enemy.speed = love.math.random(50, 80)
  table.insert(enemies, enemy)
end

function CheckCollision(x1,y1,w1,h1, x2,y2,w2,h2)--
 local bx1,by1,bx2, by2 = x1 + w1 ,y1 + h1, x2 + w2, y2 + h2
 return x1 < x2+w2 and
   x2 < x1+w1 and
    y1 < y2+h2 and
    y2 < y1+h1
end 

function love.load()
  fullscreen = false
  font = love.graphics.newImageFont( 'font_example.png', ' ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789' )
  debut = love.graphics.newImage("backgroug.png")
  loop = 0
  player.pv = 6
  up = 0
  down = 0
  left = 0
  right = 0
  gagne = false
  perdu = false



  animation1 = 0
  animation2 = 5
  animation3 = 10
  stoptimer = false
  beginning = true


  Hero = love.graphics.newImage("Sprite_hero down 1.png")
  ballombre = love.graphics.newImage("ball'ombre1.png")
  Bidoofsprite = love.graphics.newImage("autres sprites/gloupti2.png")
  backgroung = love.graphics.newImage("backgroung.png")

  player.width = 30
  player.height = 30
  player.x = 200
  player.y = 200
  player.speed = 150
  player.bump = 50

  timersec = 0
  timer = 0

  direction = 0
  directionlimit = 0
  bullet = {}
  bullet.x = nil
  bullet.y = nil
  bullet.speed = 2
  enemynumber = 9
  for i= enemynumber, 1, -1 do
    newEnemy(love.math.random(-200, 2000), love.math.random(-200, 3000))
  end
  newEnemy(100, 100)
  

end


function love.update(dt)
    if love.keyboard.isDown("x") then 
    beginning = false
   end

   if(beginning == false) then
     if(stoptimer == false and perdu == false)then
     timer = timer + 1

  for i=#enemies, 1, -1 do
    local enemy = enemies[i]
    if not enemy.removed then
    dx = (player.x - enemy.x) * (enemy.speed * dt)
    dy = (player.y - enemy.y) * (enemy.speed * dt)
    enemy.x = enemy.x + (dx * dt)
    enemy.y = enemy.y + (dy * dt)
    if CheckCollision(player.x+21, player.y+10, 19, 1, enemy.x, enemy.y, enemy.width, enemy.height)then
      player.pv = player.pv - 1
      player.y = player.y + player.bump
      down = 1
    else
      down = 0 
    end
    if CheckCollision(player.x+20, player.y+11, 1, 19, enemy.x, enemy.y, enemy.width, enemy.height)then
      player.pv = player.pv - 1
      player.x = player.x + player.bump
      left = 1
    else
      left = 0 
    end
    if CheckCollision(player.x+40, player.y+11, 1, 19, enemy.x, enemy.y, enemy.width, enemy.height)then
      player.pv = player.pv - 1
      player.x = player.x - player.bump
      right = 1
    else
      right = 0 
    end
    if CheckCollision(player.x+21, player.y+10, 19, 1, enemy.x, enemy.y, enemy.width, enemy.height)then
      player.pv = player.pv - 1
      player.y = player.y - player.bump
      down = 1
    else
      down = 0 
    end
    if bulletfired == true then
    if CheckCollision(bullet.x, bullet.y, 30, 30, enemy.x, enemy.y, enemy.width, enemy.height)then
      enemy.pv = enemy.pv - 1
      enemy.x = enemy.x + enemy.bump
    end
    end
    if enemy.pv == 0 then enemies[#enemies].removed = true 
      enemynumber = enemynumber + 1
    end
    else table.remove(enemies, i) end
  end
     timersec = math.floor(timer/60)
     end

  loop = loop + 0.5
  if (loop > animation3) then
  loop = 0

  end

   if (loop == animation2) then
    ballombre = love.graphics.newImage("ball'ombre1.png")
     elseif (loop == animation3) then
   ballombre = love.graphics.newImage("ball'ombre2.png")
     elseif (loop == animation1) then
   ballombre = love.graphics.newImage("ball'ombre1.png")
  end

   if (loop == animation2) then
    Bidoofsprite = love.graphics.newImage("autres sprites/gloupti2.png")
     elseif (loop == animation3) then
    Bidoofsprite = love.graphics.newImage("autres sprites/gloupti2.png")
     elseif (loop == animation1) then
    Bidoofsprite = love.graphics.newImage("autres sprites/gloupti3.png")
  end
 
  if love.keyboard.isScancodeDown("up") then 
  player.y = player.y - player.speed * dt 
    if (loop == animation2) then
    Hero = love.graphics.newImage("autres sprites/sprites up/Sprite_hero up2.png")
     elseif (loop == animation3) then
    Hero = love.graphics.newImage("autres sprites/sprites up/Sprite_hero up3.png")
     elseif (loop == animation1) then
    Hero = love.graphics.newImage("autres sprites/sprites up/Sprite_hero up1.png")
    end
  end
  if love.keyboard.isScancodeDown("down") then 
    player.y = player.y + player.speed * dt 
     if (loop == animation2) then
    Hero = love.graphics.newImage("Sprite_hero down 2.png")
     elseif (loop == animation3) then
    Hero = love.graphics.newImage("Sprite_hero down 3.png")
     elseif (loop == animation1) then
    Hero = love.graphics.newImage("Sprite_hero down 1.png")
    end
  end
  if love.keyboard.isScancodeDown("left") then 
    player.x = player.x - player.speed * dt 
    direction = -1000
    directionlimit = -3000
   if (loop == animation2) then
    Hero = love.graphics.newImage("autres sprites/sprites gauche/gauche1.png")
     elseif (loop == animation3) then
    Hero = love.graphics.newImage("autres sprites/sprites gauche/gauche2.png")
     elseif (loop == animation1) then
    Hero = love.graphics.newImage("autres sprites/sprites gauche/gauche3.png")
    end
  end
  if love.keyboard.isScancodeDown("right") then 
    player.x = player.x + player.speed * dt 
    direction = 1000
    directionlimit = 3000
       if (loop == animation2) then
    Hero = love.graphics.newImage("autres sprites/sprites droite/droite1.png")
     elseif (loop == animation3) then
    Hero = love.graphics.newImage("autres sprites/sprites droite/droite2.png")
     elseif (loop == animation1) then
    Hero = love.graphics.newImage("autres sprites/sprites droite/droite3.png")
     end
  end
  if love.keyboard.isScancodeDown("space") then
    bulletfired = true
    bullet.x = player.x
    bullet.y = player.y
  end
  if stoptimer == true and player.pv and timersec < 7 then
    gagne = true
  end
  if player.pv == 0 then
    perdu = true
  end

if(bulletfired == true)then
 bullet.x = bullet.x + direction * dt
if (bullet.x > directionlimit)then
  bullet.x = directionlimit


end
end

end
end


function love.draw()
 
    love.graphics.scale(1.8, 1.8)
    for i = 0, love.graphics.getWidth() / backgroung:getWidth() do
    for j = 0, love.graphics.getHeight() / backgroung:getHeight() do
     love.graphics.draw(backgroung, i * backgroung:getWidth(), j * backgroung:getHeight())
    end
   end
    if (player.pv > 0)then
     love.graphics.draw(Hero, player.x, player.y) 
    elseif(player.pv < 0)then
     stoptimer = true
    end
     for i=#enemies, 1, -1 do
    local enemy = enemies[i]
    -- draw stuff
   love.graphics.draw(Bidoofsprite, enemy.x, enemy.y)
     end
     if #enemies == 0 then
      gagne = true
    end

    love.graphics.setColor(255, 255, 255, 255)
    if (bulletfired == true) then
    love.graphics.draw(ballombre, bullet.x, bullet.y)
    end
    love.graphics.setColor(255, 255, 255, 255)
    love.graphics.setFont( font )

    love.graphics.setColor(0, 0, 0, 255)
    love.graphics.rectangle("fill", 0, 0, love.graphics.getHeight(), 82)
    love.graphics.setColor(255, 255, 255, 255)
    if perdu == false and gagne == false then
    love.graphics.print( 'Try not to die. Be careful they dont fuse.', 0, 15)
    love.graphics.print( 'YOU MUST DEFEAT ALL ENEMIES. ',0 , 0 )
    end

    love.graphics.print(player.pv, 15, 40)
    
    love.graphics.print("Your time is  :", 10, 60)
    love.graphics.print(timersec, 220, 60)
    if player.pv == 0 then
    love.graphics.print("You Suck.", 0, 0)
    love.graphics.print("Press right shift to restart", 100, 200, 0, 1.2, 1.2)
    end
    if gagne == true then
    love.graphics.print("You're good", 0, 0)
    love.graphics.print("Press right shift to restart", 100, 200, 0, 1.2, 1.2)
    end
    if beginning then
          for i = 0, love.graphics.getWidth() / backgroung:getWidth() do
        for j = 0, love.graphics.getHeight() / backgroung:getHeight() do
         love.graphics.draw(backgroung, i * backgroung:getWidth(), j * backgroung:getHeight())
        end
       end
       love.graphics.print("Salaz", 100, 100, 0, 1.8, 1.8)
        love.graphics.print("Press x to begin", 150, 200)
    end

end


function love.keypressed(key)
  if key == "escape" then 
    if fullscreen == false then
    love.window.setFullscreen(true, "desktop")
    fullscreen = true
    else
    love.window.setFullscreen(false, "desktop")
    fullscreen = false
  end
  end
    if player.pv == 0 and key == "rshift" or gagne and key == "rshift" then
    love.event.quit( "restart")
  end
end
